import { EnchantmentType, system, world } from "@minecraft/server"
import { VFX_particle, fetchDynamicData, randomNumber, updateDynamicData, writeDynamicData } from "../extended_functions.js"

world.beforeEvents.worldInitialize.subscribe((event) => {
    event.blockComponentRegistry.registerCustomComponent("ext:spike_component", {
        onTick: spike_tick,
    })
})

const spikesList = {
    "ext:spike_copper": { damage: 2.0 },
    "ext:spike_iron": { damage: 2.5 },
    "ext:spike_diamond": { damage: 3.5 }
}

const entitiesDeny = ["minecraft:item", "minecraft:snowball", "minecraft:splash_potion", "minecraft:thrown_trident", "minecraft:ender_pearl", "minecraft:xp_orb"]

function spike_tick(event) {
    const { block } = event;

    const blockLocation = block.bottomCenter();
    const dimension = world.getDimension(block.dimension.id);

    dimension.getEntitiesAtBlockLocation(blockLocation)?.forEach((entity) => {
        for (let itemInArray of entitiesDeny) {
            const projectileEntity = world.getAllPlayers()[0]
            if (itemInArray == entity.typeId) break;
            if (entity.nameTag != projectileEntity?.name) {
                entity.applyDamage(spikesList[block.typeId].damage, { damagingProjectile: projectileEntity });
                entity.clearVelocity();
                return;
            }
            entity.applyDamage(spikesList[block.typeId].damage);
        }
    })
}