import { world, system } from "@minecraft/server"
import { fetchDynamicData, updateDynamicData, writeDynamicData } from "./extended_functions.js"

import "./block_components/index.js"
import "./item_components/index.js"

console.warn("Addon Iniciada com sucesso.")

world.beforeEvents.itemUseOn.subscribe(event => {
    const { block, itemStack, isFirstEvent, source } = event
    if (itemStack.typeId == "minecraft:stick" && isFirstEvent) {
        console.warn(` Block Debug
            
Block ID: ${block.typeId}

Block Tags: ${JSON.stringify(block.getTags())}

Permutatuions: ${JSON.stringify(block.permutation.getAllStates())}

            `)
    }
    if (itemStack.typeId == "minecraft:blaze_rod" && isFirstEvent) {
        console.warn(`\nDynamic: ${JSON.stringify(world.getDynamicPropertyIds())}`)
    }
    if (itemStack.typeId == "minecraft:breeze_rod" && isFirstEvent) {
        world.clearDynamicProperties()
    }
})

const timerDynamicName = "timerGlobal"

system.runInterval(() => {
    updateDynamicData(timerDynamicName, [{ timer: 0 }]);

    const timerValue = fetchDynamicData(timerDynamicName);

    writeDynamicData(timerDynamicName, { timer: (timerValue.timer ?? 0) + 1 });

    if (timerValue.timer >= 20) writeDynamicData(timerDynamicName, { timer: 0 });
});